% ressort08.m          deux oscillateurs couples equation adjointe 
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
title ('Assimilation variationnelle pour deux  oscillateurs harmoniques couples') ;
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
tmax= 10 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
n=100

dt=tmax/n ; 
t=zeros(1,n+1);
td=zeros(1,n);
x=zeros(3,n+1);
y=zeros(3,n+1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
x(:,1:1) = x0 ; 
y(:,1:1) = y0 ; 
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
for i=1:n;
t(i+1)=t(i)+dt;
td(1,i:i) = (i-.5)*dt ; 
end ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
end ;

uuu=zeros(6,n+1); 
for i=1:n+1;
uuu(:,i:i)  = expm(t(i)*aa)*u0 ; end 


xmax=tmax+.1 ; 
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
plot(  t(1,:) , x(1:1,:), '*;;' ,    t(1,:) , uuu(1:1,:), 'r;;' ,  \
t(1,:) , x(2:2,:), '*b;;' ,   t(1,:) , uuu(2:2,:), 'b;;' ,  \ 
t(1,:) , x(3:3,:), '*g;;' ,   t(1,:) , uuu(3:3,:), 'g;;' ,  \ 
t(1,:) , mm1*uuu(1:1,:) + mm2*uuu(2:2,:) + mm3*uuu(3:3,:) , '*m;;' , \
t(1,:) , mm1*uuu(1:1,:) + mm2*uuu(2:2,:) + mm3*uuu(3:3,:) , 'm;;' ) ; 
pause


%               initialisation
masse=mm ; amort=cc; kka1 = .5 ; kka2 = 3 ; 
raideur=[ kka1 -kka1 0 ; -kka1 kka1+kka2 -kka2 ; 0 -kka2 kka2 ] ; 
xxs=zeros(3,n+1);
yys=zeros(3,n+1); 


xxx = x0 ;
yyy = y0 ; 
xxs(:,1:1)=xxx ; 
yys(:,1:1)=yyy ; 
ssiter = masse + .5*dt*amort + .25*dt*dt*raideur ; 
for i=1:n;
ga = -masse \ ( raideur*xxx + amort*yyy )  ;
xt = xxx + dt*yyy + .25*dt*dt*ga ;
yt = yyy + .5*dt * ga ; 
ga = ssiter \ ( - raideur*xt - amort*yt ) ;
xxs(:,i+1:i+1)  = xt + .25*dt*dt*ga ; 
yys(:,i+1:i+1)  = yt + .5*dt*ga ; 
end ; 

err = xxs - x ; 
axis ( [ -.1   , tmax+ .1   , -10.1 , 10.1 ]) ;
plot ( t(1,:) , err(1:1,:), '*;erreur;' , t(1,:) , err(2:2,:), '*b;;' , \
       t(1,:) , err(3:3,:), '*g;;'   ) ; pause 


%                          equation adjointe
ss = masse + .5*dt*amort + .25*dt*dt*raideur ; 
pp = zeros(3,n); qq = pp ; 
pp(:,n:n) = .5 * dt * err(:,n+1:n+1) ; 
qq(:,n:n) = 0 ; 
ymax = abs(pp(:, n:n)) ; 
ymax = max (ymax(:),abs(qq(:,n:n))) ; 
for j = 1:n-1;
jj    = n-j ; 
ro    = -ss \ (.25*dt*dt*pp(:,jj+1:jj+1) + .5*dt*qq(:,jj+1:jj+1) ) ; 
pt    = pp(:,jj+1:jj+1) + raideur*ro ; 
qt    = qq(:,jj+1:jj+1) + amort*ro ; 
rot   = - masse \ (.25*dt*dt*pt + .5*dt*qt ) ;
pp(:,jj:jj) = pt + dt*err(:,jj+1:jj+1) + raideur*rot ; 
qq(:,jj:jj) = qt + dt*pt               + amort*rot ; 
ymax = max (ymax(:),abs(pp(:,jj:jj))) ; 
ymax = max (ymax(:),abs(qq(:,jj:jj))) ; 
end ;

ymax = max(ymax(:)) ; ymax = 1.05 * ymax ;
axis ( [ -.1   , tmax+.3  , -ymax  , ymax  ] ) ;
plot (  td(1,:) , pp(1:1,:), '*;etat adjoint;',   \ 
        td(1,:) , qq(1:1,:), 'r;second etat adjoint;'  ,  \
        td(1,:) , pp(2:2,:), '*b;;' , \
        td(1,:) , qq(2:2,:), 'b;;'  ,  \
        td(1,:) , pp(3:3,:), '*g;;' , \
        td(1,:) , qq(3:3,:), 'g;;'    ) ; pause 





